package org.processmining.humbertogarciacaballero.models.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;

import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.gui.components.ColorLeyendComponent;
import org.processmining.humbertogarciacaballero.models.gui.images.ImageHelper;
import org.processmining.humbertogarciacaballero.models.model.SoundnessInformation;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsViz;

public class ToolBarGUI extends JToolBar {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    private PNetVisualizerController controller;

    private LayoutParametersGUI gui;
    private LegendGUI legendGUI;

    private ImageIcon loaderImage = null;
    private JLabel loaderLabel = null;

    private ImageIcon fitScreenImage = null;
    private ToolButton fitScreenButton = null;

    private ImageIcon rotateAntiClockwiseImage = null;
    private ToolButton rotateAntiClockwiseButton = null;

    private ImageIcon rotateClockwiseImage = null;
    private ToolButton rotateClockwiseButton = null;

    private ImageIcon executeLayoutImage = null;
    private ToolButton executeLayoutButton = null;

    private ImageIcon redoImage = null;
    private ToolButton redoButton = null;

    private ImageIcon undoImage = null;
    private ToolButton undoButton = null;

    private ImageIcon highlightPathImage = null;
    private ToggleToolButton highlightPathButton = null;

    private ImageIcon toggleSimplificationImage = null;
    private ToggleToolButton toggleSimplificationButton = null;

    private ImageIcon toggleSimplificationEdgeImage = null;
    private ToggleToolButton toggleSimplificationEdgeButton = null;

    private ImageIcon toggleLoopHighLightImage = null;
    private ToggleToolButton toggleLoopHighLightButton = null;

    private ImageIcon optionToCompleteImage = null;
    private ToggleToolButton optionToCompleteButton = null;

    private ImageIcon properCompletionImage = null;
    private ToggleToolButton properCompletionButton = null;

    private ImageIcon noDeadTasksImage = null;
    private ToggleToolButton noDeadTasksButton = null;

    private ImageIcon spanGraphImage = null;
    private ToggleToolButton spanGraphButton = null;

    private ImageIcon addImage = null;
    private ToggleToolButton addButton = null;

    private ImageIcon removeImage = null;
    private ToggleToolButton removeButton = null;

//    private JLabel pathLabel = null;
//    private JSpinner pathSpinner = null;
//    private JRadioButton pathIncoming = null;
//    private JRadioButton pathOutgoing = null;
//    private JRadioButton pathBoth = null;

    private ImageIcon optionsImage = null;
    private ToolButton optionsButton = null;

    private ImageIcon legendImage = null;
    private ToolButton legendButton = null;
    
    private ToggleToolButton shortEdgesSimplify = null;
    
    private ToggleToolButton longEdgesSimplify = null;
    
    private JCheckBox reorderNodes = null;

    public ToolBarGUI(final JFrame application, Component mainGraphPanel, SoundnessInformation soundnessInformation) {
        super();
        controller = PNetVisualizerController.getInstance();
//        controller.addObserver(this);
//        gui = new LayoutParametersGUI(application);
//        legendGUI = new LegendGUI(application, mainGraphPanel);
        setFloatable(false);

//        fitScreenImage = ImageHelper.loadImage("fit_screen.png");
//        fitScreenButton = new ToolButton(fitScreenImage);
//        fitScreenButton.setToolTipText("Fits the main graph view to screen.");
//        fitScreenButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                controller.fitViews();
//            }
//        });
//
//        executeLayoutImage = ImageHelper.loadImage("play.png");
//        executeLayoutButton = new ToolButton(executeLayoutImage);
//        executeLayoutButton.setToolTipText("(Re)Executes the layout algorithm.");
//        executeLayoutButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                controller.executeLayout(true);
//            }
//        });
//
//        optionsImage = ImageHelper.loadImage("options.png");
//        optionsButton = new ToolButton(optionsImage);
//        optionsButton.setToolTipText("Layout's options");
//        optionsButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                EventQueue.invokeLater(new Runnable() {
//                    @Override
//                    public void run() {
//                        gui.loadFormValues();
//                        gui.setVisible(true);
//                    }
//                });
//            }
//        });
//
//        rotateAntiClockwiseImage = ImageHelper.loadImage("anticlockwise_rotate.png");
//        rotateAntiClockwiseButton = new ToolButton(rotateAntiClockwiseImage);
//        rotateAntiClockwiseButton.setToolTipText("Rotates anticlockwise");
//        rotateAntiClockwiseButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                controller.rotateAnticlockwise();
//            }
//        });
//
//        rotateClockwiseImage = ImageHelper.loadImage("clockwise_rotate.png");
//        rotateClockwiseButton = new ToolButton(rotateClockwiseImage);
//        rotateClockwiseButton.setToolTipText("Rotates clockwise");
//        rotateClockwiseButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                controller.rotateClockwise();
//            }
//        });
//
//        highlightPathImage = ImageHelper.loadImage("network.png");
//        highlightPathButton = new ToggleToolButton(highlightPathImage);
//        highlightPathButton.setToolTipText("Highlights node's neighbors.");
//        highlightPathButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setHighlightNeighborsEnabled(selected);
//            }
//        });
//
//        spanGraphImage = ImageHelper.loadImage("move.png");
//        spanGraphButton = new ToggleToolButton(spanGraphImage);
//        spanGraphButton.setSelected(true);
//        spanGraphButton.setToolTipText("Moves graphs and nodes");
//        spanGraphButton.addChangeListener(new ChangeListener() {
//            @Override
//            public void stateChanged(ChangeEvent e) {
//                boolean enabled = spanGraphButton.getModel().isSelected();
//                controller.setSpanEnabled(enabled);
//            }
//        });
//
//        addImage = ImageHelper.loadImage("add.png");
//        addButton = new ToggleToolButton(addImage);
//        addButton.setSelected(false);
//        addButton.setToolTipText("Add new node");
//        addButton.addChangeListener(new ChangeListener() {
//            @Override
//            public void stateChanged(ChangeEvent e) {
//                boolean enabled = addButton.getModel().isSelected();
//                controller.setAddModeEnabled(enabled);
//            }
//        });
//
//        removeImage = ImageHelper.loadImage("remove.png");
//        removeButton = new ToggleToolButton(removeImage);
//        removeButton.setSelected(false);
//        removeButton.setToolTipText("Remove a node");
//        removeButton.addChangeListener(new ChangeListener() {
//            @Override
//            public void stateChanged(ChangeEvent e) {
//                boolean enabled = removeButton.getModel().isSelected();
//                controller.setRemoveModeEnabled(enabled);
//            }
//        });
//
//        ButtonGroup controlGroup = new ButtonGroup();
//        controlGroup.add(spanGraphButton);
//        controlGroup.add(addButton);
//        controlGroup.add(removeButton);
//
//        toggleSimplificationImage = ImageHelper.loadImage("layer.png");
//        toggleSimplificationButton = new ToggleToolButton(toggleSimplificationImage);
//        toggleSimplificationButton.setSelected(false);
//        toggleSimplificationButton.setToolTipText("(De)Simplifies layers");
//        toggleSimplificationButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setLayerSimplifierControlEnabled(selected);
//            }
//        });
//
//        toggleSimplificationEdgeImage = ImageHelper.loadImage("line.png");
//        toggleSimplificationEdgeButton = new ToggleToolButton(toggleSimplificationEdgeImage);
//        toggleSimplificationEdgeButton.setSelected(false);
//        toggleSimplificationEdgeButton.setToolTipText("(De)Simplifies edges");
//        toggleSimplificationEdgeButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setEdgeSimplifierControlEnabled(selected);
//            }
//        });
//
//        // ButtonGroup simplificationGroup = new ButtonGroup();
//        // simplificationGroup.add(toggleSimplificationButton);
//        // simplificationGroup.add(toggleSimplificationEdgeButton);
//
//        toggleLoopHighLightImage = ImageHelper.loadImage("loop_icon.png");
//        toggleLoopHighLightButton = new ToggleToolButton(toggleLoopHighLightImage);
//        toggleLoopHighLightButton.setSelected(false);
//        toggleLoopHighLightButton.setToolTipText("Look for loops");
//        toggleLoopHighLightButton.addActionListener(new ActionListener() {
//            private boolean firstTime = true;
//
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//
//                if (firstTime) {
//                    if (selected) {
//                        int loops = Utils.markLoops(controller.getData());
//                        if (loops == 0) {
//                            JOptionPane.showMessageDialog(application, "There are no loops in the process");
//                            toggleLoopHighLightButton.setToolTipText("There are no loops in the process to highlight");
//                            toggleLoopHighLightButton.setEnabled(false);
//                        } else {
//                            controller.setLoopHighlightEnabled(selected);
//                            toggleLoopHighLightButton.setToolTipText("Highlight loops in process");
//                            firstTime = false;
//                        }
//                    }
//                } else {
//                    controller.setLoopHighlightEnabled(selected);
//                }
//            }
//        });
//
//        optionToCompleteImage = ImageHelper
//                .loadImage(soundnessInformation.isOptionToComplete() == Boolean.TRUE ? "tick.png" : "tick_off.png");
//        optionToCompleteButton = new ToggleToolButton(optionToCompleteImage);
//        optionToCompleteButton.setEnabled(soundnessInformation.isOptionToComplete() == Boolean.FALSE);
//        optionToCompleteButton.setSelected(false);
//        optionToCompleteButton
//                .setToolTipText(
//                        soundnessInformation.isOptionToComplete() == Boolean.TRUE
//                                ? "Whatever happens, an instance can always mark the sink place"
//                                : (soundnessInformation.isOptionToComplete() == Boolean.FALSE
//                                        ? "Option to complete information"
//                                        : "No information about option to complete available"));
//        optionToCompleteButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setNonLiveTransitionsModeEnabled(selected);
//            }
//        });
//
//        properCompletionImage = ImageHelper
//                .loadImage(soundnessInformation.isProperCompletion() == Boolean.TRUE ? "tick.png" : "tick_off.png");
//        properCompletionButton = new ToggleToolButton(properCompletionImage);
//        properCompletionButton.setEnabled(soundnessInformation.isProperCompletion() == Boolean.FALSE);
//        properCompletionButton.setSelected(false);
//        properCompletionButton
//                .setToolTipText(
//                        soundnessInformation.isProperCompletion() == Boolean.TRUE
//                                ? "On completion, only the sink place is marked, and it is marked only once"
//                                : (soundnessInformation.isProperCompletion() == Boolean.FALSE
//                                        ? "Proper completion information"
//                                        : "No information about proper completion available"));
//        properCompletionButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setUnboundedPlacesModeEnabled(selected);
//            }
//        });
//
//        noDeadTasksImage = ImageHelper
//                .loadImage(soundnessInformation.isNoDeadTasks() == Boolean.TRUE ? "tick.png" : "tick_off.png");
//        noDeadTasksButton = new ToggleToolButton(noDeadTasksImage);
//        noDeadTasksButton.setEnabled(soundnessInformation.isNoDeadTasks() == Boolean.FALSE);
//        noDeadTasksButton.setSelected(false);
//        noDeadTasksButton
//                .setToolTipText(
//                        soundnessInformation.isNoDeadTasks() == Boolean.TRUE ? "No transition is dead"
//                                : (soundnessInformation.isOptionToComplete() == Boolean.FALSE
//                                        ? "Dead transitions information"
//                                        : "No information about dead transitions available"));
//        noDeadTasksButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setDeadTransitionsModeEnabled(selected);
//            }
//        });
//        
//        
//        shortEdgesSimplify = new ToggleToolButton(null);
//        shortEdgesSimplify.setText("Short edges");
//        shortEdgesSimplify.setToolTipText("Simplify consecutive edges");
//        shortEdgesSimplify.addActionListener(new ActionListener() {
//			@Override
//			public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setSimplifierEnable(selected || longEdgesSimplify.isSelected());
//				controller.setSimplifyShortEdgesEnabled(selected);
//				controller.executeLayout(true);
//			}
//		});
//        
//        longEdgesSimplify = new ToggleToolButton(null);
//        longEdgesSimplify.setText("Long edges");
//        longEdgesSimplify.setToolTipText("Simplify non-consecutive edges");
//        longEdgesSimplify.addActionListener(new ActionListener() {
//			@Override
//			public void actionPerformed(ActionEvent e) {
//                AbstractButton abstractButton = (AbstractButton) e.getSource();
//                boolean selected = abstractButton.getModel().isSelected();
//                controller.setSimplifierEnable(selected || shortEdgesSimplify.isSelected());
//				controller.setSimplifyLongEdgesEnabled(selected);
//				controller.setBarDrawingEnabled(selected);
//				controller.executeLayout(true);
//			}
//		});
//        
//        reorderNodes = new JCheckBox("Reorder nodes");
//        reorderNodes.addActionListener(new ActionListener() {
//			@Override
//			public void actionPerformed(ActionEvent e) {
//				AbstractButton abstractButton = (AbstractButton) e.getSource();
//				boolean selected = abstractButton.getModel().isSelected();
//				controller.setReorderNodesEnabled(selected);
//				controller.executeLayout(true);
//			}
//		});
//
////        pathLabel = new JLabel("Depth:");
////        pathLabel.setEnabled(false);
////        pathSpinner = new JSpinner();
////        pathSpinner.setModel(new SpinnerNumberModel(new Integer(1), new Integer(1), null, new Integer(1)));
////        pathSpinner.setEnabled(false);
////        ((JSpinner.DefaultEditor) pathSpinner.getEditor()).getTextField().setColumns(2);
////        pathSpinner.addChangeListener(new ChangeListener() {
////            @Override
////            public void stateChanged(ChangeEvent e) {
////                if (controller.getDepth() != (int) pathSpinner.getValue()) {
////                    controller.setDepth((int) pathSpinner.getValue());
////                }
////            }
////        });
//
////        pathIncoming = new JRadioButton("Incoming");
////        pathIncoming.setEnabled(false);
////        pathOutgoing = new JRadioButton("Outgoing");
////        pathOutgoing.setEnabled(false);
////        pathBoth = new JRadioButton("Both");
////        pathBoth.setSelected(true);
////        pathBoth.setEnabled(false);
////
////        ActionListener radioListener = new ActionListener() {
////            @Override
////            public void actionPerformed(ActionEvent e) {
////                PathMode selected;
////                if (e.getSource() == pathIncoming) {
////                    selected = PathMode.INCOMING;
////                } else if (e.getSource() == pathOutgoing) {
////                    selected = PathMode.OUTGOING;
////                } else {
////                    selected = PathMode.BOTH;
////                }
////
////                controller.setPathMode(selected);
////            }
////        };
////
////        pathIncoming.addActionListener(radioListener);
////        pathOutgoing.addActionListener(radioListener);
////        pathBoth.addActionListener(radioListener);
//
//        loaderImage = ImageHelper.loadImage("loader.gif");
//        loaderLabel = new JLabel(null, loaderImage, JLabel.CENTER);
//        loaderLabel.setVisible(false);
//        loaderLabel.setPreferredSize(new Dimension(62, 24));
//
//        undoImage = ImageHelper.loadImage("undo_icon.png");
//        undoButton = new ToolButton(undoImage);
//        undoButton.setEnabled(false);
//        undoButton.setToolTipText("Undo");
//        undoButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                loaderLabel.setVisible(true);
//                undoButton.setVisible(false);
//                redoButton.setVisible(false);
//                setUndoRedoEnabled(controller.undo());
//            }
//        });
//
//        redoImage = ImageHelper.loadImage("redo_icon.png");
//        redoButton = new ToolButton(redoImage);
//        redoButton.setEnabled(false);
//        redoButton.setToolTipText("Redo");
//        redoButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                redo();
//            }
//        });
//
////        ButtonGroup group = new ButtonGroup();
////        group.add(pathIncoming);
////        group.add(pathOutgoing);
////        group.add(pathBoth);
////
////        JPanel panel = new JPanel(new FlowLayout());
////        panel.add(pathLabel);
////        panel.add(pathSpinner);
////        panel.add(pathIncoming);
////        panel.add(pathOutgoing);
////        panel.add(pathBoth);
//
//        legendImage = ImageHelper.loadImage("legend.png");
//        legendButton = new ToolButton(legendImage);
//        legendButton.setToolTipText("Legend");
//        legendButton.addActionListener(new ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                try {
//                    LayoutOrientation original = controller.getLayoutOrientation();
//                    controller.setLayoutOrientation(LayoutOrientation.TOP_TO_BOTTOM);
//                    legendGUI.setVisible(true);
//                    controller.setLayoutOrientation(original);
//                } catch (Exception ex) {
//                    ex.printStackTrace();
//                }
//            }
//        });
        
        // PROCESS ANALYTICS CODE HERE
        final ToggleToolButton placesButton = new ToggleToolButton(ImageHelper.loadImage("circle-icon.png"));
        final ToggleToolButton transitionsButton = new ToggleToolButton(ImageHelper.loadImage("rectangle-icon.png"));
        transitionsButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AbstractButton abstractButton = (AbstractButton) e.getSource();
				boolean selected = abstractButton.getModel().isSelected();
				controller.setSelectionNodeEnabled(selected || placesButton.isSelected());
				controller.setTransitionSelectionEnabled(selected);
			}
		});
        
        placesButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AbstractButton abstractButton = (AbstractButton) e.getSource();
				boolean selected = abstractButton.getModel().isSelected();
				controller.setSelectionNodeEnabled(selected || transitionsButton.isSelected());
				controller.setTransitionSelectionEnabled(!selected);
			}
		});
        String[] comboItems = new String[ProcessAnalyticsViz.getNumberTransitions() + 1];
        String[] activities = ProcessAnalyticsViz.getActivitiesAsString();
        Arrays.sort(activities);
        System.arraycopy(activities, 0, comboItems, 1, ProcessAnalyticsViz.getNumberTransitions());
        comboItems[0] = "Select an activity";
        final JComboBox<String> combo = new JComboBox<>(comboItems);
        combo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String selected = combo.getSelectedIndex() == 0 ? null : (String) combo.getSelectedItem();
				controller.setSelectedActivity(selected);
			}
		});
        
		final ColorLeyendComponent colorLeyend = new ColorLeyendComponent("Sync-Model moves", "0", "1", ColorBrewer.getSequentialColorPalettes(false)[4].getColorPalette(10));
		final ColorLeyendComponent colorLeyend2 = new ColorLeyendComponent("Frequency", "0%", "100%", ColorBrewer.getSequentialColorPalettes(false)[8].getColorPalette(10));
		final ColorLeyendComponent colorLeyend3 = new ColorLeyendComponent("Performance", "0%", "100%", ColorBrewer.getSequentialColorPalettes(false)[6].getColorPalette(10));
        
        ButtonGroup radiogroup = new ButtonGroup();
        radiogroup.add(colorLeyend.getRadioButton());
        radiogroup.add(colorLeyend2.getRadioButton());
        radiogroup.add(colorLeyend3.getRadioButton());
        
        ActionListener listener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.setInformationMode(colorLeyend.getRadioButton().isSelected() ? 0 : (colorLeyend2.getRadioButton().isSelected() ? 1 : 2));
			}
		};
        
		colorLeyend.getRadioButton().addActionListener(listener);
		colorLeyend.getRadioButton().setSelected(true);
		colorLeyend2.getRadioButton().addActionListener(listener);
		colorLeyend3.getRadioButton().addActionListener(listener);
		
		final JComboBox<String> measureCombo = new JComboBox<>(new String[]{"Absolute", "Case", "Average"});
		measureCombo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.setFrequencyMode(measureCombo.getSelectedIndex());
			}
		});
        
        add(transitionsButton);
        add(placesButton);
        addSeparator();
        add(combo);
        addSeparator();
        add(measureCombo);
        addSeparator();
        add(colorLeyend);
        add(colorLeyend2);
        add(colorLeyend3);

        // END PROCESS ANALYTICS CODE HERE

//        add(fitScreenButton);
//        add(rotateAntiClockwiseButton);
//        add(rotateClockwiseButton);
//        add(executeLayoutButton);
//        addSeparator();
//        add(loaderLabel);
//        add(undoButton);
//        add(redoButton);
//        addSeparator();
//        add(highlightPathButton);
//        add(toggleSimplificationButton);
//        add(toggleSimplificationEdgeButton);
//        add(toggleLoopHighLightButton);
//        addSeparator();
//        add(optionToCompleteButton);
//        add(properCompletionButton);
//        add(noDeadTasksButton);
//        addSeparator();
//        add(shortEdgesSimplify);
//        add(longEdgesSimplify);
//        add(reorderNodes);
//        addSeparator();
//        add(spanGraphButton);
        // add(addButton);
        // add(removeButton);
//        addSeparator();
//        add(panel);
//        addSeparator();
//        add(optionsButton);
//        addSeparator();
//        add(legendButton);

//        controller.addCommandManagerObserver(this);
    }

    @SuppressWarnings("serial")
    private class ToolButton extends JButton {

        public ToolButton(Icon icon) {
            super(icon);
        }

        public boolean isFocusTraversable() {
            return false;
        }

        public void requestFocus() {
        }
    }

    @SuppressWarnings("serial")
    private class ToggleToolButton extends JToggleButton {

        public ToggleToolButton(Icon icon) {
            super(icon);
        }

        public boolean isFocusTraversable() {
            return false;
        }

        public void requestFocus() {
        }
    }

//    @Override
//    public void update(Observable observable, Object value) {
//        if (observable instanceof CommandManager) {
//            if (value == null) {
//                loaderLabel.setVisible(false);
//                undoButton.setVisible(true);
//                redoButton.setVisible(true);
//            } else {
//                setUndoRedoEnabled((CommandManagerState) value);
//            }
//        }
//    }
//
//    private void setUndoRedoEnabled(CommandManagerState state) {
//        redoButton.setEnabled(state.isRedo());
//        undoButton.setEnabled(state.isUndo());
//    }
//
//    public void undo() {
//        if (undoButton.isEnabled()) {
//            loaderLabel.setVisible(true);
//            undoButton.setVisible(false);
//            redoButton.setVisible(false);
//            setUndoRedoEnabled(controller.undo());
//        }
//    }
//
//    public void redo() {
//        if (redoButton.isEnabled()) {
//            loaderLabel.setVisible(true);
//            undoButton.setVisible(false);
//            redoButton.setVisible(false);
//            setUndoRedoEnabled(controller.redo());
//        }
//    }
}
