package org.processmining.humbertogarciacaballero.models.gui.action;

import java.awt.geom.Rectangle2D;

import prefuse.Display;
import prefuse.Visualization;
import prefuse.action.GroupAction;
import prefuse.util.GraphicsLib;
import prefuse.util.display.DisplayLib;

public class FitGroupBoundsAction extends GroupAction {

	private float margin;
	private long duration;
	private boolean allDisplaies;
	
	public FitGroupBoundsAction(String group, float margin, long duration, boolean allDisplaies) {
	    super(group);
		this.margin = margin;
		this.duration = duration;
		this.allDisplaies = allDisplaies;
	}
	
	@Override
	public void run(double frac) {
	    if (allDisplaies) {
	        int displayCount = getVisualization().getDisplayCount();
	        
	        for (int i = 0; i < displayCount; i++) {
	            Display d = getVisualization().getDisplay(i);
	            fit(d);
	        }    
	    } else {
	        fit(getVisualization().getDisplay(0));
	    }
	}
	
	private void fit(Display display) {
        Visualization vis = display.getVisualization();
        Rectangle2D bounds = vis.getBounds(getGroup());
        GraphicsLib.expand(bounds, margin + (int)(1/display.getScale()));
        DisplayLib.fitViewToBounds(display, bounds, duration);
	}
}
