package org.processmining.humbertogarciacaballero.models.gui.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

import org.processmining.humbertogarciacaballero.models.util.Utils;

import prefuse.Visualization;

public class PlaceHotBoxComponent extends NodeHotboxComponent {
    
    /**
     * 
     */
    private static final long serialVersionUID = 8625796699679716160L;

    /**
     * Create the frame.
     */
    public PlaceHotBoxComponent(Visualization vis) {
        super(vis);
        initGui();
    }

    private void initGui() {
        setBackground(new Color(0, 0, 0, 0));
        setSize(new Dimension(309, 132));

        setLayout(new BorderLayout());

        JPanel panel = new JPanel();
        panel.setBackground(new Color(0, 0, 0, 0));
        add(panel, BorderLayout.SOUTH);
        JButton button = new JButton(new CloseAction());
        panel.add(button);

        JPanel panel_1 = new JPanel();
        panel_1.setBackground(new Color(0, 0, 0, 0));
        add(panel_1, BorderLayout.NORTH);
        JButton button_1 = new JButton(new PathFromBeginning());
        panel_1.add(button_1);

        JPanel panel_2 = new JPanel();
        panel_2.setBackground(new Color(0, 0, 0, 0));
        add(panel_2, BorderLayout.EAST);
        JButton button_2 = new JButton("Add to reachable");
        panel_2.add(button_2);

        JPanel panel_3 = new JPanel();
        FlowLayout flowLayout = (FlowLayout) panel_3.getLayout();
        flowLayout.setHgap(0);
        panel_3.setBackground(new Color(0, 0, 0, 0));
        add(panel_3, BorderLayout.WEST);
        JButton button_3 = new JButton(new AddToMarking());
        panel_3.add(button_3);
        
        JButton btNewButton_2 = new JButton(new RemoveFromMarking("0", true));
        panel_3.add(btNewButton_2);
        
        JButton btnNewButton = new JButton(new RemoveFromMarking("-1", false));
        panel_3.add(btnNewButton);
    }
    
    private class PathFromBeginning extends AbstractAction {
        public PathFromBeginning() {
            super("Path from the beginning", null);
        }

        public void actionPerformed(ActionEvent e) {
            Utils.higlightPathFromBeginning(item.getGraph(), item);
        }
    }

    private class AddToMarking extends AbstractAction {
        public AddToMarking() {
            super("+1", null);
//            putValue(SHORT_DESCRIPTION, "Adds one marking");
        }

        public void actionPerformed(ActionEvent e) {
            controller.addToMarking(item);
        }
    }
    
    private class RemoveFromMarking extends AbstractAction {
        private boolean removeAll;
        public RemoveFromMarking(String text, boolean removeAll) {
            super(text, null);
//            putValue(SHORT_DESCRIPTION, "Removes marking from this node");
            this.removeAll = removeAll;
        }

        public void actionPerformed(ActionEvent e) {
            controller.removeFromMarking(item, removeAll);
        }
    }

    private class RightAction extends AbstractAction {
        public RightAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
            super(text, icon);
            putValue(SHORT_DESCRIPTION, desc);
            putValue(MNEMONIC_KEY, mnemonic);
        }

        public void actionPerformed(ActionEvent e) {

        }
    }
}
