package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.Cursor;
import java.awt.event.MouseEvent;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Display;
import prefuse.controls.ControlAdapter;
import prefuse.data.Node;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class AddNodeControl extends ControlAdapter {

    private NodeItem source;
    private NodeItem target;
    private PNetVisualizerController controller;

    public AddNodeControl() {
        super();
        controller = PNetVisualizerController.getInstance();
    }

    /**
     * @see prefuse.controls.Control#itemEntered(prefuse.visual.VisualItem,
     *      java.awt.event.MouseEvent)
     */
    public void itemEntered(VisualItem item, MouseEvent e) {
        Display d = (Display) e.getSource();
        d.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    }

    /**
     * @see prefuse.controls.Control#itemExited(prefuse.visual.VisualItem,
     *      java.awt.event.MouseEvent)
     */
    public void itemExited(VisualItem item, MouseEvent e) {
        Display d = (Display) e.getSource();
        d.setCursor(Cursor.getDefaultCursor());
    }

    @Override
    public void itemClicked(VisualItem item, MouseEvent e) {
        if (!SwingUtilities.isLeftMouseButton(e) && !SwingUtilities.isRightMouseButton(e))
            return;

        if (item instanceof NodeItem) {
            NodeItem nodeItem = (NodeItem) item;
            if (e.isControlDown()) {
                nodeItem.setHighlighted(true);
                if (source == null) {
                    source = nodeItem;
                    runActivities(nodeItem);
                } else if (source != item) {
                    runActivities(nodeItem);
                    target = nodeItem;
                    source.setHighlighted(false);
                    target.setHighlighted(false);
                    source = null;
                    target = null;
                    try {
                        controller.addNewNode((Node) source.getSourceTuple(), (Node) target.getSourceTuple());
                    } catch (IllegalArgumentException ex) {
                        JOptionPane.showMessageDialog(e.getComponent(), ex.getMessage(), "Warning!",
                                JOptionPane.WARNING_MESSAGE);
                    }
                } else {
                    source.setHighlighted(false);
                    source = null;
                    runActivities(nodeItem);
                }


            } else {
                controller.addNewNode((Node) nodeItem.getSourceTuple(), SwingUtilities.isRightMouseButton(e));
            }
        }
    }
    
    private void runActivities(VisualItem item) {
        item.getVisualization().cancel(PNConstants.VIS_HIGHLIGHT_ACTIONS_NAME);
        item.getVisualization().run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
        item.getVisualization().run(PNConstants.VIS_HIGHLIGHT_ACTIONS_NAME);
    }
}
