package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.event.MouseEvent;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Visualization;
import prefuse.controls.ControlAdapter;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

public class EdgeSimplifierControl extends ControlAdapter {

    private Visualization vis;

    public EdgeSimplifierControl(Visualization vis) {
        this.vis = vis;
    }

    /**
     * @see prefuse.controls.Control#itemEntered(prefuse.visual.VisualItem,
     *      java.awt.event.MouseEvent)
     */
    public void itemEntered(VisualItem item, MouseEvent e) {
        if (item instanceof EdgeItem) {
            item.setHighlighted(true);
            runAnimations(item.getVisualization());
        }
    }

    /**
     * @see prefuse.controls.Control#itemExited(prefuse.visual.VisualItem,
     *      java.awt.event.MouseEvent)
     */
    public void itemExited(VisualItem item, MouseEvent e) {
        if (item instanceof EdgeItem) {
            item.setHighlighted(false);
            runAnimations(item.getVisualization());
        }
    }

    /**
     * @see prefuse.controls.Control#itemClicked(prefuse.visual.VisualItem,
     *      java.awt.event.MouseEvent)
     */
    public void itemClicked(VisualItem item, MouseEvent e) {
        if (item instanceof EdgeItem) {
            boolean simplify = item.getBoolean(PNConstants.SIMPLIFIED_KEY);
            item.setBoolean(PNConstants.EDGE_SIMPLIFICABLE, !simplify);
            item.setBoolean(PNConstants.EDGE_FORCE_SIMPLIFICATION, !simplify);
            if (!simplify)
                item.setBoolean(PNConstants.SIMPLIFIED_KEY, !simplify);

            item.getVisualization().cancel(PNConstants.VIS_ANIMATE_LAYOUT_ACTIONS_NAME);
            item.getVisualization().run(PNConstants.VIS_LAYOUT_NO_PAINT_ACTIONS_NAME);
            item.getVisualization().run(PNConstants.VIS_ANIMATE_LAYOUT_ACTIONS_NAME);
        }
    }

    private void runAnimations(Visualization vis) {
        vis.run(PNConstants.VIS_FILL_EDGES_ACTIONS_NAME);
        vis.run(PNConstants.VIS_STROKE_EDGES_ACTIONS_NAME);
        vis.run(PNConstants.VIS_REPAINT_ACTIONS_NAME);
    }

    public void setEnabled(boolean enabled) {
        super.setEnabled(enabled);
//        vis.setInteractive(GraphVisualization.GRAPH_EDGES_GROUP, null, enabled);
    }
}
