package org.processmining.humbertogarciacaballero.models.gui.render;

import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Path2D;
import java.awt.geom.Rectangle2D;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.util.Utils;

import prefuse.render.EdgeRenderer;
import prefuse.visual.AggregateItem;
import prefuse.visual.DecoratorItem;
import prefuse.visual.VisualItem;

public class BarRenderer extends EdgeRenderer {



    private PNetVisualizerController controller;
    private Path2D m_path = new GeneralPath();

    public BarRenderer() {
        controller = PNetVisualizerController.getInstance();
    }

    protected Shape getRawShape(VisualItem item) {
        m_path.reset();
        DecoratorItem decorator = (DecoratorItem) item;
        AggregateItem decoratedItem = (AggregateItem) decorator.getDecoratedItem();
        double n1x, n1y, n2x, n2y;
        Rectangle2D bounds = Utils.getBounds(decoratedItem);

        if (Utils.checkTopSimplification(decoratedItem)) {
            switch (controller.getLayoutOrientation()) {
            case TOP_TO_BOTTOM:
                n1x = bounds.getX();
                n1y = bounds.getY() - controller.getEdgeLandingOffset() - 1;
                n2x = n1x + bounds.getWidth();
                n2y = n1y;
                break;
            case BOTTOM_TO_TOP:
                n1x = bounds.getX();
                n1y = bounds.getMaxY() + controller.getEdgeLandingOffset() + 1;
                n2x = n1x + bounds.getWidth();
                n2y = n1y;
                break;
            case LEFT_TO_RIGHT:
                n1x = bounds.getX() - controller.getEdgeLandingOffset() - 1;
                n1y = bounds.getY();
                n2x = n1x;
                n2y = n1y + bounds.getHeight();
                break;
            default:
                n1x = bounds.getMaxX() + controller.getEdgeLandingOffset() + 1;
                n1y = bounds.getY();
                n2x = n1x;
                n2y = n1y + bounds.getHeight();
                break;
            }

            m_line.setLine(n1x, n1y, n2x, n2y);
            m_path.append(m_line, false);
        }

        if (Utils.checkBottomSimplification(decoratedItem)) {
            switch (controller.getLayoutOrientation()) {
            case TOP_TO_BOTTOM:
                n1x = bounds.getX();
                n1y = bounds.getMaxY() + controller.getEdgeLandingOffset() + 1;
                n2x = n1x + bounds.getWidth();
                n2y = n1y;
                break;
            case BOTTOM_TO_TOP:
                n1x = bounds.getX();
                n1y = bounds.getY() - controller.getEdgeLandingOffset() - 1;
                n2x = n1x + bounds.getWidth();
                n2y = n1y;
                break;
            case LEFT_TO_RIGHT:
                n1x = bounds.getMaxX() + controller.getEdgeLandingOffset() + 1;
                n1y = bounds.getY();
                n2x = n1x;
                n2y = n1y + bounds.getHeight();
                break;
            default:
                n1x = bounds.getX() - controller.getEdgeLandingOffset() - 1;
                n1y = bounds.getY();
                n2x = n1x;
                n2y = n1y + bounds.getHeight();
                break;
            }

            m_line.setLine(n1x, n1y, n2x, n2y);
            m_path.append(m_line, false);
        }

        return m_path;
    }
}
