package org.processmining.humbertogarciacaballero.models.model.layout.stage.sequencer;

public enum SequencingStrategy {
	HYBRID_CROSSING_STRATEGY("Hybrid crossing strategy", HybridCrossingSequencer.class), HEURISTIC_CROSSING_STRATEGY("Heuristic crossing strategy", HeuristicCrossingSequencer.class);
	
	private final String label;
	
	private final Class<? extends Sequencer> algorithm;
	
	private SequencingStrategy(String label, Class<? extends Sequencer> algorithm) {
		this.label = label;
		this.algorithm = algorithm;
	}
	
	public Class<? extends Sequencer> getAlgorithm() {
		return algorithm;
	}
	
	public String toString() {
		return label;
	}
}
