package org.processmining.humbertogarciacaballero.plugins;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.humbertogarciacaballero.models.gui.PNetVisualizerGUI;
import org.processmining.humbertogarciacaballero.models.model.SoundnessInformation;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.transitionsystem.CoverabilityGraph;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsVizViews;

import prefuse.data.Graph;

public class InteractiveVisualizer {

	private PNetVisualizerGUI visualizer;

	protected JComponent visualizeWithAll(PluginContext context, PetrinetGraph n, Marking m) {
		SoundnessInformation information = new SoundnessInformation();
		Graph graph = PluginUtils.netToGraph(context, n, m, information);
		CoverabilityGraph cg = null; //CGGenerator.getCoverabilityGraph((Petrinet) n, m, new EfficientPetrinetSemanticsImpl(n));
		visualizer = new PNetVisualizerGUI(graph, information, cg);
		return visualizer.getRootPane();
	}
	
	protected JComponent visualizeWithAll(PluginContext context, AcceptingPetriNet n) {
		SoundnessInformation information = new SoundnessInformation();
		Graph graph = PluginUtils.netToGraph(context, n, information);
		CoverabilityGraph cg = null; //CGGenerator.getCoverabilityGraph(n.getNet(), n.getInitialMarking(), new EfficientPetrinetSemanticsImpl(n.getNet()));
		visualizer = new PNetVisualizerGUI(graph, information, cg);
		return visualizer.getRootPane();
	}
	
	protected JComponent visualizeWithConformance(PluginContext context, PetrinetGraph n, XLog log, PNRepResult replayResult, ProcessAnalyticsVizViews pa) {
		Marking m = new Marking();
//		m.add(getInitialMarking(n));
		SoundnessInformation information = new SoundnessInformation();
		Graph graph = PluginUtils.netToGraph(context, n, null, information);
		CoverabilityGraph cg = null; //CGGenerator.getCoverabilityGraph((Petrinet) n, m, new EfficientPetrinetSemanticsImpl(n));
		visualizer = new PNetVisualizerGUI(graph, information, cg,pa);
		return visualizer.getRootPane();
	}

	private Place getInitialMarking(PetrinetGraph n) {
		for(Place p: n.getPlaces())
			if(n.getInEdges(p).size()==0)
				return p;
		return null;
	}
	
}
