package org.processmining.prabhakardixit.processanalytics;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.swing.JPanel;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;
import org.processmining.plugins.petrinet.replayresult.StepTypes;
import org.processmining.plugins.replayer.replayresult.SyncReplayResult;
import org.processmining.prabhakardixit.featureSelection.CalculateLogHeuristics;
import org.processmining.prabhakardixit.featureSelection.SelectFeatures;
import org.processmining.prabhakardixit.processanalytics.models.ActivityStartOptions;
import org.processmining.prabhakardixit.processanalytics.models.ChartView;
import org.processmining.prabhakardixit.processanalytics.models.GraphData;
import org.processmining.prabhakardixit.processanalytics.models.ProcessView;
import org.processmining.prabhakardixit.processanalytics.models.TimeView;

import prefuse.data.Node;
import weka.core.Attribute;

public class CopyOfProcessAnalyticsViz {
	protected static PNRepResult replayResult_current; //always use this for analysis
	protected static PNRepResult replayResult_original; //this is created only once, not to be reset, used to update current replayResult as n when needed

	protected static Petrinet pn;
	protected static XLog log;
	private static Map<Integer, Map<XEventClass, Set<Place>>> syncLogMovePlaces = new HashMap<Integer, Map<XEventClass, Set<Place>>>(); //save the map of log moves
	//	protected static Map<Transition, Set<Integer>> syncGoodMoves = new HashMap<Transition, Set<Integer>>();
	//	protected static Map<String, Set<Integer>> caseLogMoves = new HashMap<String, Set<Integer>>();
	//	protected static Map<Transition, Set<Integer>> caseModelMoves = new HashMap<Transition, Set<Integer>>();

	protected static Set<CaseLevelInfo> caseLevelInfo = new HashSet<CaseLevelInfo>();

	public static int frequencyMode = 0; //0 absolute, 1 case, 2 average per case	
	//abs frequencies starts
	public static Map<Transition, Float> syncMovesFrequency = new HashMap<Transition, Float>();
	public static Map<Transition, Float> modelMovesFrequency = new HashMap<Transition, Float>();
	public static Map<Set<Place>, Map<String, Float>> logMovesFrequency = new HashMap<Set<Place>, Map<String, Float>>();
	//abs frequencies ends
	//case frequencies starts
	public static Map<Transition, Float> syncMovesFrequencyCase = new HashMap<Transition, Float>();
	public static Map<Transition, Float> modelMovesFrequencyCase = new HashMap<Transition, Float>();
	public static Map<Set<Place>, Map<String, Float>> logMovesFrequencyCase = new HashMap<Set<Place>, Map<String, Float>>();
	//case frequencies ends
	//average frequencies starts
	public static Map<Transition, Float> syncMovesFrequencyAvg = new HashMap<Transition, Float>();
	public static Map<Transition, Float> modelMovesFrequencyAvg = new HashMap<Transition, Float>();
	public static Map<Set<Place>, Map<String, Float>> logMovesFrequencyAvg = new HashMap<Set<Place>, Map<String, Float>>();
	//average frequencies ends
	// References to the current structures
	public static Map<Transition, Float> syncMovesFrequencyCurrent = syncMovesFrequency;
	public static Map<Transition, Float> modelMovesFrequencyCurrent = modelMovesFrequency;
	public static Map<Set<Place>, Map<String, Float>> logMovesFrequencyCurrent = logMovesFrequency;
	protected static TimeView timeView;
	protected static ProcessView processView;
	protected static ChartView graphView;
	protected static GraphData graphData;
	protected static ActivityStartOptions activityOption;

	protected static PluginContext context;

	protected static SelectFeatures featureSelection = new SelectFeatures();
	ArrayList<Attribute> attInfo = new ArrayList<Attribute>();
	CalculateLogHeuristics logHeuristics;

	public static Transition selectedTran; //selected transition for Activity based graph analysis

	public static PetrinetNode findNode(Node n) {
		PetrinetNode t = null;
		for (PetrinetNode tran : getPetrinet().getNodes()) {
			if (tran.getLocalID().localNodeID().toString().equals(n.getString(PNConstants.NODE_ID_KEY))) {
				t = tran;
				break;
			}
		}
		return t;
	}

	protected static PairwisePerformanceInfo pairwisePerformance = new PairwisePerformanceInfo();

	public CalculateLogHeuristics getLogHeuristics() {
		return logHeuristics;
	}

	public void setLogHeuristics(CalculateLogHeuristics logHeuristics) {
		this.logHeuristics = logHeuristics;
	}

	public static SelectFeatures getFeatureSelection() {
		return featureSelection;
	}

	public static void setFeatureSelection(SelectFeatures featureSelection) {
		CopyOfProcessAnalyticsViz.featureSelection = featureSelection;
	}

	public static PluginContext getContext() {
		return context;
	}

	public static void setContext(PluginContext context) {
		CopyOfProcessAnalyticsViz.context = context;
	}

	public static GraphData getGraphData() {
		return graphData;
	}

	public static void setGraphData(GraphData graphData) {
		CopyOfProcessAnalyticsViz.graphData = graphData;
	}

	protected static Map<String, Map<Double, Double>> synchornousCount = new HashMap<String, Map<Double, Double>>(); //Event, Bin Value, Count
	protected static Map<String, Map<Double, Double>> logMoveCount = new HashMap<String, Map<Double, Double>>(); //Event, Bin Value, Count

	protected static Set<Transition> tranSet = new HashSet<Transition>();
	protected static Set<Place> placeSet = new HashSet<Place>();

	public static Set<Place> getPlaceSet() {
		return placeSet;
	}

	public static void setPlaceSet(Set<Place> placeSet) {
		CopyOfProcessAnalyticsViz.placeSet = placeSet;
	}

	public static Set<Transition> getTranSet() {
		return tranSet;
	}

	public static void setTranSet(Set<Transition> tranSet) {
		CopyOfProcessAnalyticsViz.tranSet = tranSet;
	}

	protected static JPanel panel;
	public static String selectedActivity;

	public static JPanel getPanel() {
		return panel;
	}

	public static void setPanel(JPanel panel) {
		CopyOfProcessAnalyticsViz.panel = panel;
	}

	public static Transition getSelectedTran() {
		return selectedTran;
	}

	public static void setSelectedTran(Transition selectedTran) {
		CopyOfProcessAnalyticsViz.selectedTran = selectedTran;
	}

	public static TimeView getTimeView() {
		return timeView;
	}

	public static void setTimeView(TimeView timeView) {
		CopyOfProcessAnalyticsViz.timeView = timeView;
	}

	public static void viewCaseStart(Set<Transition> tranSet) {
		//		viewCaseStart(tranSet, null);
	}

	public static ChartView getGraphView() {
		return graphView;
	}

	public static void setGraphView(ChartView graphView) {
		CopyOfProcessAnalyticsViz.graphView = graphView;
	}

	public static void loadLogMovePlaces() {
		//		viewCaseStart(new HashSet<Transition>(pn.getTransitions()), new HashSet<Place>(pn.getPlaces()), TimeView.HOURS);
		Set<Place> marking = new HashSet<Place>();

		// Clear structures
		logMovesFrequency.clear();
		logMovesFrequencyCase.clear();
		logMovesFrequencyAvg.clear();
		syncMovesFrequency.clear();
		syncMovesFrequencyCase.clear();
		syncMovesFrequencyAvg.clear();
		modelMovesFrequency.clear();
		modelMovesFrequencyCase.clear();
		modelMovesFrequencyAvg.clear();

		// Iterate over cases
		for (SyncReplayResult sync : replayResult_current) {
			Map<Set<Place>, Boolean> caseLogAux = new HashMap<>();
			Map<Transition, Boolean> caseSynAux = new HashMap<>();
			Map<Transition, Boolean> caseModelAux = new HashMap<>();

			CaseLevelInfo cli = new CaseLevelInfo(sync.hashCode(), sync.getTraceIndex().size());
			marking.clear();
			marking.add(getInitialMarking(pn));
			Map<XEventClass, Set<Place>> syncLogMoves = new HashMap<XEventClass, Set<Place>>();
			for (int actIndex = 0; actIndex < sync.getStepTypes().size(); actIndex++) {
				StepTypes type = sync.getStepTypes().get(actIndex);
				Object stepObj = sync.getNodeInstance().get(actIndex);
				switch (type) {
					case L :
						//add all places enabled currently as log moves
						if (syncLogMoves.containsKey(stepObj)) {
							Set<Place> places = syncLogMoves.get(stepObj);
							places.addAll(marking);
							syncLogMoves.put((XEventClass) stepObj, places);
						} else {
							syncLogMoves.put((XEventClass) stepObj, new HashSet<Place>(marking));
						}
						Set<Place> placeKeys = ProcessAnalyticsUtils.getCurrentMarkingPlaceKey(logMovesFrequency,
								marking);
						if (placeKeys != null) {
							if (logMovesFrequency.get(placeKeys).containsKey(stepObj.toString())) {
								logMovesFrequency.get(placeKeys).put(stepObj.toString(),
										logMovesFrequency.get(placeKeys).get(stepObj.toString()) + 1);

								if (!caseLogAux.containsKey(placeKeys)) {
									logMovesFrequencyCase.get(placeKeys).put(stepObj.toString(),
											logMovesFrequencyCase.get(placeKeys).get(stepObj.toString()) + 1);
									caseLogAux.put(placeKeys, Boolean.TRUE);
								}
							} else {
								logMovesFrequency.get(placeKeys).put(stepObj.toString(), 1f);

								// Case 
								Map<String, Float> map2 = new HashMap<String, Float>();
								map2.put(stepObj.toString(), 1f);
								Set<Place> key;
								logMovesFrequencyCase.put(key = new HashSet<Place>(marking), map2);
								caseLogAux.put(key, Boolean.TRUE);
							}
						} else {
							Map<String, Float> map = new HashMap<String, Float>();
							map.put(stepObj.toString(), 1f);
							Set<Place> key;
							logMovesFrequency.put(key = new HashSet<Place>(marking), map);

							// Case 
							Map<String, Float> map2 = new HashMap<String, Float>();
							map2.put(stepObj.toString(), 1f);
							logMovesFrequencyCase.put(key, map2);
							caseLogAux.put(key, Boolean.TRUE);

						}
						cli.setLogMoves(stepObj.toString());
						break;
					case LMGOOD :
						//						if (stepObj.equals(selectedTran))
						//						if (syncGoodMoves.containsKey(stepObj))
						//							syncGoodMoves.get(stepObj).add(sync.hashCode());
						//						else
						//							syncGoodMoves.put((Transition) stepObj, new HashSet<Integer>(sync.hashCode()));

						if (syncMovesFrequency.containsKey(stepObj)) {
							syncMovesFrequency.put((Transition) stepObj, syncMovesFrequency.get(stepObj) + 1);
							
							// Case
							if (!caseSynAux.containsKey((Transition)stepObj)) {
								syncMovesFrequencyCase.put((Transition) stepObj, syncMovesFrequencyCase.get(stepObj) + 1);
								caseSynAux.put((Transition) stepObj, Boolean.TRUE);
							}
						} else {
							syncMovesFrequency.put((Transition) stepObj, 1f);
							
							// Case
							syncMovesFrequencyCase.put((Transition) stepObj, 1f);
							caseSynAux.put((Transition) stepObj, Boolean.TRUE);
						}
						ProcessAnalyticsUtils.execTran((Transition) stepObj, pn, marking);
						cli.setSyncTrans((Transition) stepObj);
						break;

					case MINVI :
					case MREAL :
						//execute transition
						ProcessAnalyticsUtils.execTran((Transition) stepObj, pn, marking);
						if (modelMovesFrequency.containsKey(stepObj)) {
							modelMovesFrequency.put((Transition) stepObj, modelMovesFrequency.get(stepObj) + 1);
							
							// Case
							if (!caseModelAux.containsKey((Transition) stepObj)) {
								modelMovesFrequencyCase.put((Transition) stepObj, modelMovesFrequencyCase.get(stepObj) + 1);
								caseModelAux.put((Transition) stepObj, Boolean.TRUE);
							}
						} else {
							modelMovesFrequency.put((Transition) stepObj, 1f);
							
							// Case
							modelMovesFrequencyCase.put((Transition) stepObj, 1f);
							caseModelAux.put((Transition) stepObj, Boolean.TRUE);
						}
						cli.setModelMoveTrans((Transition) stepObj);
						break;
					case LMNOGOOD :
					case LMREPLACED :
					case LMSWAPPED :
						// unable to project this case, stop
				}
			}
			syncLogMovePlaces.put(sync.hashCode(), syncLogMoves);
		}
		
		// Average per case
		for (Set<Place> key : logMovesFrequencyCase.keySet()) {
			Map<String, Float> value = logMovesFrequencyCase.get(key);
			for (String activity : value.keySet()) {
				Map<String, Float> map;
				if (logMovesFrequencyAvg.containsKey(key)) {
					map = logMovesFrequencyAvg.get(key);
				} else {
					map = new HashMap<>();
					logMovesFrequencyAvg.put(key, map);
				}
				
				map.put(activity, value.get(activity) / replayResult_current.size());
			}
		}
		for (Transition key : modelMovesFrequencyCase.keySet()) {
			modelMovesFrequencyAvg.put(key, modelMovesFrequencyCase.get(key) / replayResult_current.size());
		}
		for (Transition key : syncMovesFrequencyCase.keySet()) {
			syncMovesFrequencyAvg.put(key, syncMovesFrequencyCase.get(key) / replayResult_current.size());
		}
		
		ProcessAnalyticsUtils.printLogMoves(syncLogMovePlaces, replayResult_current, pn.getPlaces());
		ProcessAnalyticsUtils.printLogMoves(syncMovesFrequency, logMovesFrequency, modelMovesFrequency);

	}

	public static Petrinet getPetrinet() {
		return pn;
	}

	public static void setPetrinet(Petrinet pn) {
		CopyOfProcessAnalyticsViz.pn = pn;
	}

	public static PNRepResult getReplayResult() {
		return replayResult_current;
	}

	public static void setReplayResult(PNRepResult replayResult) {
		CopyOfProcessAnalyticsViz.replayResult_current = replayResult;
		loadLogMovePlaces();
	}

	public static XLog getLog() {
		return log;
	}

	public static void setLog(XLog log) {
		CopyOfProcessAnalyticsViz.log = log;
	}

	public static ProcessView getProcessView() {
		return processView;
	}

	public static void setProcessView(ProcessView processView) {
		CopyOfProcessAnalyticsViz.processView = processView;
	}

	private static Place getInitialMarking(PetrinetGraph n) {
		for (Place p : n.getPlaces())
			if (n.getInEdges(p).size() == 0)
				return p;
		return null;
	}

	public static PNRepResult getReplayResult_original() {
		return replayResult_original;
	}

	public static void setReplayResult_original(PNRepResult replayResult_original) {
		CopyOfProcessAnalyticsViz.replayResult_original = replayResult_original;
	}

	public static ActivityStartOptions getActivityOption() {
		return activityOption;
	}

	public static void setActivityOption(ActivityStartOptions activityOption) {
		CopyOfProcessAnalyticsViz.activityOption = activityOption;
	}

	public static PairwisePerformanceInfo getPairwisePerformance() {
		return pairwisePerformance;
	}

	public static void setPairwisePerformance(PairwisePerformanceInfo pairwisePerformance) {
		CopyOfProcessAnalyticsViz.pairwisePerformance = pairwisePerformance;
	}

	public static String[] getActivitiesAsString() {
		String[] activities = new String[pn.getTransitions().size()];
		int i = 0;
		for (Transition t : pn.getTransitions()) {
			activities[i++] = t.getLabel();
		}

		return activities;
	}

	public static int getNumberTransitions() {
		return pn.getTransitions().size();
	}

	public static void setSelectedActivity(String activity) {
		selectedActivity = activity;
	}
	
	public static void setFrequencyMode(int mode) {
		frequencyMode = mode;
		switch (mode) {
			case 0:
				syncMovesFrequencyCurrent = syncMovesFrequency;
				modelMovesFrequencyCurrent = modelMovesFrequency;
				logMovesFrequencyCurrent = logMovesFrequency;
				break;
			case 1:
				syncMovesFrequencyCurrent = syncMovesFrequencyCase;
				modelMovesFrequencyCurrent = modelMovesFrequencyCase;
				logMovesFrequencyCurrent = logMovesFrequencyCase;
				break;
			default:
				syncMovesFrequencyCurrent = syncMovesFrequencyAvg;
				modelMovesFrequencyCurrent = modelMovesFrequencyAvg;
				logMovesFrequencyCurrent = logMovesFrequencyAvg;
				
		}
	}
}
