package org.processmining.prabhakardixit.processanalytics;

import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;

import prefuse.controls.ControlAdapter;
import prefuse.util.PrefuseLib;
import prefuse.visual.DecoratorItem;
import prefuse.visual.VisualItem;

/**
 * Control that executes an action when the mouse passes over an item.
 * 
 * @author <a href="http://jheer.org">jeffrey heer</a>
 */
public class HoverControl extends ControlAdapter {

	/**
	 * Create a new HoverActionControl.
	 * 
	 * @param action
	 *            the action to run upon mouse-over. The action is run both upon
	 *            entering and upon exiting the item.
	 */
	public HoverControl() {

	}

	/**
	 * @see prefuse.controls.Control#itemEntered(prefuse.visual.VisualItem,
	 *      java.awt.event.MouseEvent)
	 */
	public void itemEntered(VisualItem item, MouseEvent e) {
//		item.getVisualization().getFocusGroup("focusgroup").addTuple(item);
		item.setHighlighted(true);
		DecoratorItem decorator = (DecoratorItem) item.getVisualization().getGroup("labeldecorator").tuples().next();
		decorator.setString("label", item.getString("activity"));
		decorator.setVisible(true);
		Rectangle2D b = decorator.getBounds();
		VisualItem node = decorator.getDecoratedItem();
        Rectangle2D bounds = node.getBounds();
        PrefuseLib.setX(decorator, null, bounds.getCenterX());
        PrefuseLib.setY(decorator, null, bounds.getCenterY());
//		item.getVisualization().reset();
		item.getVisualization().repaint();
		
		
	}

	/**
	 * @see prefuse.controls.Control#itemExited(prefuse.visual.VisualItem,
	 *      java.awt.event.MouseEvent)
	 */
	public void itemExited(VisualItem item, MouseEvent e) {
		item.getString("activity");
		item.setHighlighted(false);
//		item.getVisualization().getFocusGroup("focusgroup").removeTuple(item);
	}
}